define("io.ox/office/spreadsheet/utils/sheetutils",["io.ox/office/tk/utils","io.ox/office/tk/utils/enum","io.ox/office/tk/utils/logger","io.ox/office/tk/locale/localedata","io.ox/office/tk/render/font","io.ox/office/spreadsheet/utils/errorcode","io.ox/office/spreadsheet/utils/address","io.ox/office/spreadsheet/utils/interval","io.ox/office/spreadsheet/utils/range","io.ox/office/spreadsheet/utils/range3d","io.ox/office/spreadsheet/utils/addressarray","io.ox/office/spreadsheet/utils/intervalarray","io.ox/office/spreadsheet/utils/rangearray","io.ox/office/spreadsheet/utils/range3darray","io.ox/office/spreadsheet/utils/addressset","io.ox/office/spreadsheet/utils/intervalset","io.ox/office/spreadsheet/utils/rangeset","io.ox/office/spreadsheet/utils/changedescriptor","io.ox/office/spreadsheet/utils/movedescriptor","gettext!io.ox/office/spreadsheet/main"],function(e,t,r,n,i,o,a,s,c,d,f,l,u,g,p,h,T,A,x,E){"use strict";function L(e){return"rtl"===e?"right":"left"}var N={l:"borderLeft",r:"borderRight",t:"borderTop",b:"borderBottom",d:"borderDown",u:"borderUp",v:"borderInsideVert",h:"borderInsideHor"},O={left:"left",center:"center",right:"right",justify:"justify",distribute:"justify",fillAcross:"left",centerAcross:"center"},C={};r.extend(C,{enable:"spreadsheet:log-models",prefix:"MODEL"}),C.ErrorCode=o,C.Address=a,C.Interval=s,C.Range=c,C.Range3D=d,C.AddressArray=f,C.IntervalArray=l,C.RangeArray=u,C.Range3DArray=g,C.AddressSet=p,C.IntervalSet=h,C.RangeSet=T,C.ChangeDescriptor=A,C.MoveDescriptor=x,C.CELL_POOL_ID="cell",C.MAX_NAME_LENGTH=255,C.MAX_FILL_CELL_COUNT=2e4,C.MAX_AUTOFILL_COL_ROW_COUNT=100,C.MAX_MERGED_RANGES_COUNT=1e3,C.MAX_UNMERGE_CELL_COUNT=5e3,C.MAX_CHANGE_COLS_COUNT=5e3,C.MAX_CHANGE_ROWS_COUNT=5e3,C.MAX_SORT_LINES_COUNT=5e3,C.MAX_SORT_LINE_LENGTH=100,C.MAX_LENGTH_STANDARD_CELL=11,C.MAX_LENGTH_STANDARD_EDIT=21,C.MAX_LENGTH_STANDARD_FORMULA=20,C.MIN_CELL_SIZE=5,C.MULTI_SELECTION=!e.TOUCHDEVICE,C.SheetType=t.create("worksheet chartsheet macrosheet dialogsheet"),C.SplitMode=t.create("split frozen frozenSplit");var D=C.Direction=t.create("left right up down"),I=C.MergeMode=t.create("merge horizontal vertical unmerge");return C.UpdateMode=t.create("deleteSheet renameSheet relabelName moveCells cutPaste"),C.SortDirection=t.create("vertical horizontal"),C.AnchorMode=t.create("absolute oneCell twoCell"),C.makeRejected=function(e){return(new $.Deferred).reject({cause:e})},C.getNameKey=function(e){return e.toUpperCase()},C.getTableKey=function(e){return e.toUpperCase()},C.getSheetName=function(e){return _.noI18n.fix(E("Sheet%1$d",_.noI18n(e)))},C.getTableName=function(){return _.noI18n.fix(E.pgettext("filter","Table"))},C.getTableColName=function(){return _.noI18n.fix(E.pgettext("filter","Column"))},C.hasWrappingAttributes=function(e){var t=e.cell;return t.wrapText||"justify"===t.alignHor||"justify"===t.alignVert},C.getTextOrientation=function(e,t,r){var o="string"==typeof r?i.getTextDirection(r):n.DIR,a=O[t];if(!a)switch(typeof e){case"string":a=L(e===r?o:i.getTextDirection(e));break;case"number":a="right";break;default:a=null===e?L(i.DEFAULT_TEXT_DIRECTION):"center"}return{textDir:o,cssTextAlign:a,baseBoxAlign:"justify"===a?L(o):a}},C.getOuterBorderKey=function(e,t){return e?t?"l":"r":t?"t":"b"},C.getInnerBorderKey=function(e){return e?"v":"h"},C.getBorderName=function(e){return N[e]},C.getOuterBorderName=function(e,t){return N[C.getOuterBorderKey(e,t)]},C.getInnerBorderName=function(e){return N[C.getInnerBorderKey(e)]},C.getTextPadding=function(e){return Math.ceil(e/4)},C.getTotalCellPadding=function(e){return 2*C.getTextPadding(e)+1},C.isVerticalDir=function(e){return e===D.UP||e===D.DOWN},C.isLeadingDir=function(e){return e===D.LEFT||e===D.UP},C.getDirection=function(e,t){return e?t?D.UP:D.DOWN:t?D.LEFT:D.RIGHT},C.getAdjacentRange=function(e,t,r){var n=!C.isVerticalDir(t),i=e.clone();return C.isLeadingDir(t)?(i.start.move(-r,n),i.end.set(e.start.get(n)-1,n)):(i.start.set(e.end.get(n)+1,n),i.end.move(r,n)),i},C.isOriginCell=function(e,t,r){switch(r){case I.MERGE:return t.startsAt(e);case I.HORIZONTAL:return t.start[0]===e[0];case I.VERTICAL:return t.start[1]===e[1]}return!1},C.getIteratorRanges=function(t,r){function n(e,t,r,n){var i=c.create(e,t,r,n);i.orig=l.orig,i.index=o,g.push(i)}var i=e.getBooleanOption(r,"reverse",!1),o=e.getIntegerOption(r,"startIndex",0),a=e.getOption(r,"startAddress",null),s=e.getBooleanOption(r,"skipStart",!1),d=e.getBooleanOption(r,"wrap",!1),f=u.map(t,function(e,t){var r=e.clone();return r.orig=e,r.index=t,r});if(!a&&0===o)return f;var l=f[o],g=new u;if(!i||d){if(a){var p=a[0]+(i!==s?1:0);p===l.start[0]?n(l.start[0],a[1],l.end[0],l.end[1]):(p<=l.end[0]&&n(p,a[1],l.end[0],a[1]),a[1]<l.end[1]&&n(l.start[0],a[1]+1,l.end[0],l.end[1]))}else i||g.push(l);g.append(f.slice(o+1))}if(i||d)if(g.append(f.slice(0,o)),a){var h=a[0]-(i===s?1:0);h===l.end[0]?n(l.start[0],l.start[1],l.end[0],a[1]):(l.start[1]<a[1]&&n(l.start[0],l.start[1],l.end[0],a[1]-1),l.start[0]<=h&&n(l.start[0],a[1],h,a[1]))}else i&&g.push(l);return g},C});